#!/bin/bash
# von +Start DOSBox.sh übernommen
[[ ! -n "$(aconnect -o | grep -e TiMidity -e FluidSynth)" ]] && needs_synth="1"

function midi_synth() {
    [[ "$needs_synth" != "1" ]] && return

    case "$1" in
        "start")
            timidity -Os -iAD &
            i=0
            until [[ -n "$(aconnect -o | grep TiMidity)" || "$i" -ge 10 ]]; do
                sleep 1
                ((i++))
            done
            ;;
        "stop")
            killall timidity
            ;;
        *)
            ;;
    esac
}

midi_synth start
# Ergänzugen für den kc85emu-Emulator
# Parameter in Variablen para für DOSBOX-Aufruf ermitteln
arg=$1
spielepfad=${arg#*"kc85emu"}
uuufile="${arg%/*}/INITIAL.UUU"
# Ist es ein FLOPPY-Spiel
if [ -f $uuufile ]; then
  spielepfad="${spielepfad%/*}/INITIAL.UUU"
fi
echo "SPIELEPFAD =" ${spielepfad}
# opt = Parameter für Aufruf von kc85emu, Standard = "/4 /K1 /F0 /B=100 "
opt="/4 /K1 /F0 /B=100 " 
optfile="${arg}.opt"
# wenn Options-Datei existiert, dann Parameter daher holen
# es wird nur die erste Zeile beachtet
if [ -f $optfile ]; then
  IFS=$'\n' read -d '' -r -a optzeile < ${optfile}
  opt="${optzeile[0]}"
fi
# dname = Pfad der Spiele-Datei und dazugehörigen kc85emu Optionen
dname="C:""${spielepfad////\\}"" ${opt}"
echo "SPIELEPFAD für DOSBOX = " ${dname}
para="C:\KC85EMU.EXE "
# wenn durch DOSBOX nicht nur der Emulator aufgerufen werden soll, 
# dann die automatisch zu startende Spiel-Datei mit den dazugehörigen
# kc85emu Optionen zusätzlich als Aufruf Paramter zu DOSBOX
if [[ "$arg" != *.sh ]]; then
  para+="${dname}"
fi
# DOSBOX Mapping-Datei für Joystick zum Keyoard ermitteln
arg+=".map"
# Standard-Mapping-File = "/home/pi/RetroPie/roms/kc85emu/standard.map"
mappingfile="/home/pi/RetroPie/roms/kc85emu/standard.map"
# wenn es zum Spiel-Programm eigene Mapping-Datei gibt, dann die verwenden
if [ -f $arg ]; then
  mappingfile=$arg
fi
# DOSBOX holt sich Konfigurationsdaten aus "/home/pi/RetroPie/roms/kc85emu/kc85emu.conf"
# und erwartet als Mapping-File "/home/pi/RetroPie/roms/kc85emu/kc85emu.map
# Deshalb aktuelle Mapping-Datei nach kc85emu.map kopieren
cp $mappingfile /home/pi/RetroPie/roms/kc85emu/kc85emu.map
# Wenn die Datei "mein_pad" existiert, muss die Mapping-Datei wegen Verwendung eines
# anderen Controllers aktualisiert werden
meinpad="/home/pi/RetroPie/roms/kc85emu/mein_pad"
if [ -f ${meinpad} ]; then
  #Mapping-File an ev. anderes Gamepad anpassen
  #Array arr nimmt zeilenweise die bisherige Mapping-Datei auf
  mapfile -t arr <"/home/pi/RetroPie/roms/kc85emu/kc85emu.map"
  #Variablen mit neue Belegung aus "mein_pad" einfügen
  source ${meinpad}
  #Entsprechen Inhalt von mein_pad, Zuordnungen Controller-Keyboard aktualisieren
  anz=${#arr[*]}
  for ((i=0; i<$anz; i++))
    do
    for ((j=0; j<14; j++))
      do
      abtn="alt"$j
      nbtn="neu"$j
      if [[ ${arr[$i]} == *"${!abtn}"* ]]; then
        if [ -n "${!nbtn}" ]; then
        arr[$i]="${arr[$i]/${!abtn}/${!nbtn}}"
        fi
      fi
      done
    done
  # aktualisierte Mapping-Datei schreiben
  printf "%s\n" "${arr[@]}" >"/home/pi/RetroPie/roms/kc85emu/kc85emu.map"
fi
echo "PARAMETER = "${para}
echo "MAPPING-FILE = "${mappingfile}
"/opt/retropie/emulators/dosbox/bin/dosbox" -c "${para}" -c "exit" -exit -conf "/home/pi/RetroPie/roms/kc85emu/kc85emu.conf"
midi_synth stop
